unit UnidadLogin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, jpeg, ExtCtrls, DB, shellapi, ADODB, inifiles, aes, base64;

type
  TformLogin = class(TForm)
    conexionADO: TADOConnection;
    Image1: TImage;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    txtUsuario: TEdit;
    txtContrasena: TEdit;
    bIniciar: TBitBtn;
    bOpciones: TBitBtn;
    bCancelar: TBitBtn;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    txtBDServidor: TEdit;
    txtBDPuerto: TEdit;
    txtBDBD: TEdit;
    txtProveedor: TEdit;
    Label3: TLabel;
    txtDriver: TEdit;
    Label4: TLabel;
    opRecordarContrasena: TCheckBox;
    procedure bCancelarClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bIniciarClick(Sender: TObject);
    procedure bOpcionesClick(Sender: TObject);
    procedure Image1Click(Sender: TObject);
  private
    { Private declarations }

  public
    { Public declarations }
  end;

var
  formLogin: TformLogin;

const
   //para encriptacin de contraseas en AES
   claveEncriptacionTexto = '5f3ddfJ*nt2v7Wp';

implementation

{$R *.dfm}

//encriptar datos
function encriptar (Str, Clave : String) : String;
var
  Src: TStringStream;
  Dst: TMemoryStream;
  Size: Integer;
  Key: TAESKey;
  ExpandedKey: TAESExpandedKey;
begin
  Result:= EmptyStr;
  Src:= TStringStream.Create(Str);
  try
    Dst:= TMemoryStream.Create;
    try
      // Preparamos la clave, lo ideal es que tenga 32 caracteres
      FillChar(Key,Sizeof(Key),#0);
      if Length(Clave) > Sizeof(Key) then
        move(PChar(Clave)^,Key,Sizeof(key))
      else
        move(PChar(Clave)^,Key,Length(Clave));
      AEsExpandKey(ExpandedKey,Key);
      // Guardamos el tamao del texto original
      Size:= Src.Size;
      Dst.WriteBuffer(Size,Sizeof(Size));
      // Ciframos el texto
      AESEncryptStreamECB(Src,Dst,ExpandedKey);
      // Lo codificamos a base64
      Result:= BinToStr(Dst.Memory,Dst.Size);
    finally
      Dst.Free;
    end;
  finally
    Src.Free;
  end;
end;

//desencriptar datos
function desencriptar (Str, Clave : String): String;
var
  Src: TMemoryStream;
  Dst: TStringStream;
  Size: Integer;
  Key: TAESKey;
  ExpandedKey: TAESExpandedKey;
begin
  Result:= EmptyStr;
  Src:= TMemoryStream.Create;
  try
    Dst:= TStringStream.Create(Str);
    try
      StrToStream(Str, Src);
      Src.Position:= 0;
      FillChar(Key,Sizeof(Key),#0);
      if Length(Clave) > Sizeof(Key) then
        move(PChar(Clave)^,Key,Sizeof(key))
      else
        move(PChar(Clave)^,Key,Length(Clave));
      AESExpandKey(ExpandedKey,Key);
      // Leemos el tamao del texto
      try
        Src.ReadBuffer(Size,Sizeof(Size));
        AESDecryptStreamECB(Src,Dst,ExpandedKey);
        Dst.Size:= Size;
        Result:= Dst.DataString;
      except
        Result := '';
      end;
    finally
      Dst.Free;
    end;
  finally
    Src.Free;
  end;
end;

//lee un valor booleano de un fichero INI
function leBoolINI (clave, cadena : string;
    defecto : boolean) : boolean;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := readbool (clave, cadena, defecto);
  finally
    free;
  end;
end;

//lee un valor numrico de un fichero INI
function leNumINI (clave, cadena : string;
    defecto : Integer) : Integer;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := ReadInteger (clave, cadena, defecto);
  finally
    free;
  end;
end;

//lee un valor string de un fichero INI
function leCadINI (clave, cadena : string;
    defecto : String) : String;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := ReadString (clave, cadena, defecto);
  finally
    free;
  end;
end;

//escribe un valor string en un fichero INI
procedure esCadINI (clave, cadena : string; valor : String);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    WriteString (clave, cadena, valor);
  finally
    free;
  end;
end;

//escribe un valor boolean en un fichero INI
procedure esBoolINI (clave, cadena : string; valor : Boolean);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    WriteBool (clave, cadena, valor);
  finally
    free;
  end;
end;

//escribe un valor numrico en un fichero INI
procedure esNumINI (clave, cadena : string; valor : Integer);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    WriteInteger (clave, cadena, valor);
  finally
    free;
  end;
end;

procedure TformLogin.bCancelarClick(Sender: TObject);
begin
  close;
end;

procedure TformLogin.FormCreate(Sender: TObject);
begin
  Height := 193;

  opRecordarContrasena.Checked :=
      leBoolINI('Base de datos', 'Tipo BD MySQL', false);
  txtUsuario.Text :=
      leCadINI('Base de datos', 'Tipo BD MySQL - Usuario', '');
  if opRecordarContrasena.Checked then
    txtContrasena.Text :=
        desencriptar (leCadINI('Base de datos', 'Tipo BD MySQL - Contrasea', ''),
        claveEncriptacionTexto);
  txtBDServidor.Text := leCadINI('Base de datos', 'Tipo BD MySQL - Servidor', '');
  txtBDPuerto.Text := leCadINI('Base de datos', 'Tipo BD MySQL - Puerto', '3306');
  txtBDBD.Text := leCadINI('Base de datos', 'Tipo BD MySQL - Nombre BD', '');
  txtProveedor.Text :=
      leCadINI('Base de datos', 'Tipo BD MySQL - Proveedor', 'MSDASQL.1');
  txtDriver.Text :=
      leCadINI('Base de datos', 'Tipo BD MySQL - Driver ODBC',
          'MySQL ODBC 5.1 Driver');
end;

procedure TformLogin.bIniciarClick(Sender: TObject);
var
  versionBD : string;
  valorParametro1, valorParametro2 : string;
  accesoSiDistinta : string;
begin
  if (txtUsuario.Text = '') or (txtBDServidor.Text = '') or
      (txtBDBD.Text = '') then
  begin
    MessageDlg('Falta datos por introducir para poder iniciar la sesin.',
        mtWarning, [mbok], 0);
    txtUsuario.SetFocus;
  end
  else
  begin
    esCadINI('Base de datos', 'Tipo BD MySQL - Usuario', txtUsuario.Text);
    if opRecordarContrasena.Checked then
      esCadINI('Base de datos', 'Tipo BD MySQL - Contrasea',
          trim(encriptar (txtContrasena.Text, claveEncriptacionTexto)));
    esCadINI('Base de datos', 'Tipo BD MySQL - Servidor', txtBDServidor.Text);
    esCadINI('Base de datos', 'Tipo BD MySQL - Puerto', txtBDPuerto.Text);
    esCadINI('Base de datos', 'Tipo BD MySQL - Nombre BD', txtBDBD.Text);
    esBoolINI('Base de datos', 'Tipo BD MySQL', opRecordarContrasena.Checked);

    conexionADO.Close;
    conexionADO.Provider := txtProveedor.text;
    conexionADO.ConnectionString :=
          'Provider=' + txtProveedor.text + ';' +
          'Persist Security Info=True;' +
          'Extended Properties="DRIVER={' + txtDriver.Text + '};DESC=;' +
          'DATABASE=' + txtBDBD.Text + ';' +
          'SERVER=' + txtBDServidor.text + ';' +
          'UID=' + txtUsuario.Text + ';' +
          'PASSWORD=' + txtContrasena.Text + ';' +
          'PORT=' + txtBDPuerto.text + ';' +
          'OPTION=131072;STMT=;"';
    try
      conexionADO.Connected := true;

      // Aqu ir el cdigo de carga del formulario principal
      // de la aplicacin, puesto que ha pasado el proceso de
      // inicio de sesin (usuario y contrasea vlidos)
      MessageDlg('Conectado al servidor MySQL mediante ADO.',
          mtInformation, [mbok], 0);

    except
      on e : exception do
      begin
        MessageDlg ('No se ha podido conectar con el servidor: [' +
            txtBDServidor.Text +
            ']. Compruebe que el servicio de MySQL est iniciado y que ha ' +
            'escrito correctamente el nombre/ip del servidor.' +
            chr(13) + chr(13) +
            'A continuacin la descripcin completa del error:' + chr(13) +
            e.ClassName + chr(13) + e.Message,
            mtError, [mbok], 0);
        Exit;
      end;
    end;
  end;
end;

procedure TformLogin.bOpcionesClick(Sender: TObject);
begin
  if Height = 340 then
  begin
    Height := 193;
    bOpciones.Caption := 'Opciones >>';
  end
  else
  begin
    Height := 340;
    bOpciones.Caption := 'Opciones <<';
  end;
end;

procedure TformLogin.Image1Click(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.
